****************************************************************************
* Project:	ultraDev
* Module:	automatic resetter example
* Code:		ultra
* Created:	23.12.2019
* Notes:	Example how to use the resetter inserter code to preform a reset
*			when needed. When you upload a new prg-file the atari needs to be
*			resetted.
*			Keep in mind you need to do the first reset and if your atari
*			crashes you need to reset it too;)
* Modified:
* Changes:
*
* (c) 2019 cream
****************************************************************************
	jmp		start

****************************************************************************
	include "UDAll.s"

****************************************************************************
start:
	pea		prg(pc)
	move.w	#$0026,-(sp)
	trap	#$0e
	adda.l	#6,sp
	rts

****************************************************************************
prg:
	// just call this routine periodically 
	jsr		setadma
prg2:
	bra		prg2

****************************************************************************

setadma


   clr.b    $FFFF8901

    * Writing DMA begin address
   move.l	#playBuf,d1
 
   swap		d1
   move.b	d1,$FFFF8903
      * Order important, first Hi-byte !
   swap		d1
   clr.l	d2
   move.b	d1,d2
   lsr.w	#8,d1
   move.b	d1,$FFFF8905
   move.b	d2,$FFFF8907
  
   move.l	#playBufEnd,d1
   
   swap		d1
   move.b	d1,$FFFF890F
   swap		d1
   move.b	d1,d2
   lsr.w	#8,d1
   move.b	d1,$FFFF8911
   move.b	d2,$FFFF8913

  *Mode set 

   move.b	#$02,$FFFF8921
      * 25033 Hz stereo
*  move.b     #$82,$FFFF8921.w   * 25033 Hz mono

finDMAset

* Start playback:

;	move.b	#1,$FFFF8901
	     * Start playback, single pass mode - stops at end
  move.b  #3,$FFFF8901
       * Start playback, loop mode  - stops not self. Stop by resetting bit 0 .
	rts
	even
playBuf:
	dc.b	0,0,0,0,0,0,0
	dc.b	0,0,0,0,0,0,0
	dc.b	0,0,0,0,0,0,0
	dc.b	0,0,0,0,0,0,0
	dc.b	0,0,0,0,0,0,0
	dc.b	0,0,0,0,0,0,0
	dc.b	0,0,0,0,0,0,0
	dc.b	0,0,0,0,0,0,0
	dc.b	0,0,0,0,0,0,0
	dc.b	0,0,0,0,0,0,0
	dc.b	0,0,0,0,0,0,0
	dc.b	0,0,0,0,0,0,0
	dc.b	0,0,0,0,0,0,0
	dc.b	0,0,0,0,0,0,0
	dc.b	0,0,0,0,0,0,0
	dc.b	0,0,0,0,0,0,0
playBufEnd
	even